//
//  MyAlertView.m
//  自定义AlertView
//
//  Created by macbook on 16/9/12.
//  Copyright © 2016年 郑卓青. All rights reserved.
//

#import "MyAlertView.h"
#import "UIView+Frame.h"
#import "MBProgressHUD+YS.h"

#define SCREENWIDTH [UIScreen mainScreen].bounds.size.width
#define SCREENHEIGHT [UIScreen mainScreen].bounds.size.height

#define APPCOLOR [UIColor colorWithRed:255.0/255.0 green:95.0/255.0 blue:0.0/255.0 alpha:1.0]
@interface MyAlertView ()
@property (nonatomic, strong) UIView *bgView;
@property (nonatomic,strong) UIView *alertBgView;
@end


@implementation MyAlertView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.layer.cornerRadius = 10;
        self.backgroundColor = [UIColor clearColor];
        self.clipsToBounds = YES;

        self.alertBgView=[[UIView alloc]initWithFrame:CGRectMake(0,0, self.width, self.height)];
        [self addSubview:self.alertBgView];

        UIImageView *titleVeiw=[[UIImageView alloc]initWithFrame:CGRectMake(0, 10, self.width, 55)];
        titleVeiw.userInteractionEnabled=YES;
        titleVeiw.image=[UIImage imageNamed:@"notice_title"];
        [self.alertBgView addSubview:titleVeiw];
        
        UILabel *titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(CGRectGetMaxX(titleVeiw.frame)+10, 0, self.alertBgView.width, 30)];
        titleLabel.text=@"分类编辑";
        titleLabel.textColor=[UIColor whiteColor];
        titleLabel.textAlignment = NSTextAlignmentCenter;
        [titleVeiw addSubview:titleLabel];
        
        UIView *Witeview=[[UIView alloc]initWithFrame:CGRectMake(0, CGRectGetMaxY(titleVeiw.frame), self.width, self.height-55)];
        Witeview.backgroundColor=[UIColor whiteColor];
        [self addSubview:Witeview];
        
        UILabel *goodsName=[[UILabel alloc]initWithFrame:CGRectMake(35, 25, 30, 25)];
        goodsName.text=@"名称";
        goodsName.textAlignment=NSTextAlignmentCenter;
        goodsName.font=[UIFont systemFontOfSize:15];
        [Witeview addSubview:goodsName];
        
        UITextField *goodsTF = [[UITextField alloc] initWithFrame:CGRectMake(CGRectGetMaxX(goodsName.frame)+3, 25, 140, 25)];
        goodsTF.tag = 100;
        goodsTF.layer.borderWidth = 1;
        goodsTF.layer.borderColor = [UIColor blackColor].CGColor;
        goodsTF.layer.cornerRadius = 5;
        goodsTF.secureTextEntry = NO;
        [Witeview addSubview:goodsTF];
        
        UILabel *sortLabel=[[UILabel alloc]initWithFrame:CGRectMake(35,CGRectGetMaxY(goodsName.frame)+25 , 30, 25)];
        sortLabel.text=@"排序";
        sortLabel.textAlignment=NSTextAlignmentCenter;
        sortLabel.font=[UIFont systemFontOfSize:15];
        [Witeview addSubview:sortLabel];
        
        
        UITextField *sortTF = [[UITextField alloc] initWithFrame:CGRectMake(CGRectGetMaxX(sortLabel.frame)+3, CGRectGetMaxY(goodsTF.frame)+24, 140, 25)];
        sortTF.tag = 200;
        sortTF.layer.borderWidth = 1;
        sortTF.keyboardType = UIKeyboardTypeNumberPad;
        sortTF.layer.borderColor = [UIColor blackColor].CGColor;
        sortTF.layer.cornerRadius = 5;
        sortTF.secureTextEntry = NO;
        [Witeview addSubview:sortTF];
        
        UIButton *cancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        cancelBtn.frame = CGRectMake(self.alertBgView.width-43,-6,50, 50);
        [cancelBtn addTarget:self action:@selector(cancelClick:) forControlEvents:UIControlEventTouchUpInside];
        [cancelBtn setImage:[UIImage imageNamed:@"notice_close"]forState:UIControlStateNormal];
        [ self.alertBgView addSubview:cancelBtn];
        
        UIButton *confirmBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        confirmBtn.frame = CGRectMake((self.width-90)*0.5,CGRectGetMaxY(sortTF.frame)+38,90, 27);
        [confirmBtn setBackgroundColor:APPCOLOR];
        confirmBtn.layer.cornerRadius = 5;
        [confirmBtn addTarget:self action:@selector(saveClickButton:) forControlEvents:UIControlEventTouchUpInside];
        [confirmBtn setTitle:@"保存" forState:UIControlStateNormal];
        [Witeview addSubview:confirmBtn];

        [[NSNotificationCenter  defaultCenter] addObserver:self selector:@selector(keyboardWillChange:) name:UIKeyboardWillChangeFrameNotification  object:nil];
    }
    return self;
}

-(void)cancelClick:(UIButton*)canlBtn{

    [self close];
}

-(void)saveClickButton:(UIButton*)saveBtn{
    
    if ([self.delegate respondsToSelector:@selector(saveClickButton:)]) {
        [self.delegate saveClickButton:saveBtn];
    }
    
    UITextField *name = [saveBtn.superview viewWithTag:100];
    
    UITextField *sort=[saveBtn.superview viewWithTag:200];
    
    if (name.text.length&&sort.text.length) {
        NSLog(@"名称：%@", name.text);
        NSLog(@"排序: %@",sort.text);
         [self close];
        [MBProgressHUD showSuccess:@"保存成功!"];
    }
    else{
    
        [MBProgressHUD showError:@"不能为空!"];
    }
  
}
- (void)show
{
    if (self.bgView) return;
    UIWindow *window = [UIApplication sharedApplication].keyWindow;
    
    self.bgView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, SCREENWIDTH, SCREENHEIGHT)];

    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tap:)];
    [self.bgView addGestureRecognizer:tap];
    
    self.bgView.userInteractionEnabled = YES;
    self.bgView.backgroundColor = [UIColor blackColor];
    self.bgView.alpha = 0.2;
    [window addSubview:self.bgView];
    [window addSubview:self];
    
}

- (void)close
{
    [self.bgView removeFromSuperview];
     self.bgView = nil;
    [self removeFromSuperview];

}

- (void)tap:(UITapGestureRecognizer *)tap
{
    [self close];
}

- (void)keyboardWillChange:(NSNotification  *)notification
{
    
    // 1.获取键盘的Y值
    NSDictionary *dict  = notification.userInfo;
    CGRect keyboardFrame = [dict[UIKeyboardFrameEndUserInfoKey] CGRectValue];
    CGFloat keyboardY = keyboardFrame.origin.y;
    // 获取动画执行时间
    CGFloat duration = [dict[UIKeyboardAnimationDurationUserInfoKey]doubleValue];
    // 2.计算需要移动的距离
    CGFloat selfY = keyboardY - self.height - 50;
    
    [UIView animateWithDuration:duration delay:0.0 options:7 << 16 animations:^{
        // 需要执行动画的代码
        self.y = selfY;
        self.bgView.alpha = 0.5;
    } completion:^(BOOL finished) {
        // 动画执行完毕执行的代码
        if (_bgView == nil) {
            //  [self.textField resignFirstResponder];
            [self removeFromSuperview];
        }
    }];
}

@end
